# coding: utf-8

"""
    Terra Scientific Pipelines Service

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from teaspoons_client.models.pipeline_quota import PipelineQuota
from teaspoons_client.models.pipeline_user_provided_input_definition import PipelineUserProvidedInputDefinition
from typing import Optional, Set
from typing_extensions import Self

class PipelineWithDetails(BaseModel):
    """
    Object containing the pipeline identifier, display name, description, type, and required inputs of a Pipeline. 
    """ # noqa: E501
    pipeline_name: StrictStr = Field(description="The identifier string for the Pipeline. ", alias="pipelineName")
    display_name: StrictStr = Field(description="The display name for the Pipeline. ", alias="displayName")
    pipeline_version: StrictInt = Field(description="An identifier Integer for the Pipeline Version. ", alias="pipelineVersion")
    description: StrictStr = Field(description="The description for the Pipeline. ")
    type: StrictStr = Field(description="The general type of the Pipeline. ")
    inputs: List[PipelineUserProvidedInputDefinition] = Field(description="A list of user-provided input fields and specifications for the Pipeline. ")
    pipeline_quota: PipelineQuota = Field(alias="pipelineQuota")
    __properties: ClassVar[List[str]] = ["pipelineName", "displayName", "pipelineVersion", "description", "type", "inputs", "pipelineQuota"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PipelineWithDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in inputs (list)
        _items = []
        if self.inputs:
            for _item_inputs in self.inputs:
                if _item_inputs:
                    _items.append(_item_inputs.to_dict())
            _dict['inputs'] = _items
        # override the default output from pydantic by calling `to_dict()` of pipeline_quota
        if self.pipeline_quota:
            _dict['pipelineQuota'] = self.pipeline_quota.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PipelineWithDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "pipelineName": obj.get("pipelineName"),
            "displayName": obj.get("displayName"),
            "pipelineVersion": obj.get("pipelineVersion"),
            "description": obj.get("description"),
            "type": obj.get("type"),
            "inputs": [PipelineUserProvidedInputDefinition.from_dict(_item) for _item in obj["inputs"]] if obj.get("inputs") is not None else None,
            "pipelineQuota": PipelineQuota.from_dict(obj["pipelineQuota"]) if obj.get("pipelineQuota") is not None else None
        })
        return _obj


